/*
 *  Funkce
 *  (c)2001 by Jan Krupa(krupaj@mobilnews.cz)
 */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <math.h>
#include <graphics.h>

// Path to the EGAVGA.BGI(this value should be changed)
#define GR_PATH ""

// DEFINICE FUNKCE (!!! def. obor=R !!!)
#define FUNKCE1 sin(x)*pow(x,2)/4
#define FUNKCE1_STR "sin(x)*pow(x,2)/4"

float x_start,x_end,x_vzd,krok_x, y_start,y_end,y_vzd,krok_y;

float funkce1(float x)
{
  return (FUNKCE1);
}

float f_max()
{
  int ix1;
  float jx1;

  jx1=funkce1(x_start);
  for (ix1=1; ix1<getmaxx(); ix1++)
  {
    if (funkce1((ix1*krok_x)+x_start) > jx1) jx1=funkce1((ix1*krok_x)+x_start);
  }

  return jx1;
}

float f_min()
{
  int ix1;
  float jx1;

  jx1=funkce1(x_start);
  for (ix1=1; ix1<getmaxx(); ix1++)
  {
    if (funkce1((ix1*krok_x)+x_start) < jx1) jx1=funkce1((ix1*krok_x)+x_start);
  }

  return jx1;
}

void draw_osy()
{
  int ix1;
  char sx1[10];

  // draw osa y
  setcolor(7);
  setlinestyle(SOLID_LINE,1,2);
  if ((x_start < 0) && (x_end > 0))
  {
    line (int(fabs(x_start)/krok_x),1,int(fabs(x_start)/krok_x),getmaxy());
  }

  // rovnobezne s osou x
  setcolor(8);
  setlinestyle(DOTTED_LINE,1,1);
  for (ix1=int(y_start); ix1<=int(y_end); ix1++)
  {
    if (ix1!=0)
    {
      line (1,getmaxy()-(int(float(ix1)/krok_y)+int(fabs(y_start)/krok_y)),
            getmaxx(),getmaxy()-(int(float(ix1)/krok_y)+int(fabs(y_start)/krok_y)));
    }
    itoa (ix1,sx1,10);
    outtextxy (int(fabs(x_start)/krok_x)+2,
               getmaxy()-(int(float(ix1)/krok_y)+int(fabs(y_start)/krok_y))+2,sx1);
  }

  // draw osa x
  setcolor(7);
  setlinestyle(SOLID_LINE,1,2);
  if ((y_start < 0) && (y_end > 0))
  {
    line (1,getmaxy()-int(fabs(y_start)/krok_y),getmaxx(),getmaxy()-int(fabs(y_start)/krok_y));
  }

  // rovnobezne s osou y
  setcolor(8);
  setlinestyle(DOTTED_LINE,1,1);
  for (ix1=int(x_start); ix1<=int(x_end); ix1++)
  {
    if (ix1!=0)
    {
      line (int(float(ix1)/krok_x)+int(fabs(x_start)/krok_x),1,
            int(float(ix1)/krok_x)+int(fabs(x_start)/krok_x),getmaxy());
    }
    itoa (ix1,sx1,10);
    outtextxy (int(float(ix1)/krok_x)+int(fabs(x_start)/krok_x)+2,
               getmaxy()-int(fabs(y_start)/krok_y)+2,sx1);
  }
  setlinestyle(SOLID_LINE,1,1);
}

void draw_funkce()
{
  int ix1,ix2,ix3;
  char sx1[50];

  cleardevice();

  // some debug info :)
/*gotoxy (1,1);
  printf("x_vzd==%f y_vzd==%f\n",x_vzd,y_vzd);
  printf("krok_x==%f krok_y==%f\n",krok_x,krok_y);
  printf("x_start==%f x_end==%f\n",x_start,x_end);
  printf("y_start==%f y_end==%f\n",y_start,y_end);
  printf("y_start==%f\n",y_start);
  printf("y_end==%f\n",y_end);*/

  draw_osy();

  setcolor(14);
  ix3=(funkce1((1*krok_x)+x_start)/krok_y) + int(fabs(y_start)/krok_y);
  for (ix1=1; ix1<getmaxx(); ix1++)
  {
    ix2=(funkce1((ix1*krok_x)+x_start)/krok_y) + int(fabs(y_start)/krok_y);
    //putpixel(ix1,getmaxy()-ix2,15);
    line ((ix1-1),getmaxy()-ix3,ix1,getmaxy()-ix2);
    ix3=ix2;
  }

  setfillstyle(1,0); bar (1,1,299,54);
  setcolor(7); rectangle(0,0,300,55);
  setcolor(15); outtextxy (5,5,"Funkce v1.2");
   setcolor(7); outtextxy (5,15,"(c)2001 by Jan Krupa");
                outtextxy (5,25,"(krupaj@mobilnews.cz)");
  strcpy(sx1,"f(x): y=");
  strcat(sx1,FUNKCE1_STR);
  setcolor(8);  outtextxy (5,40,sx1);
}

void main()
{
  int konec;
  char ch;
  float j1,j2;

  // inicializace grafiky
  int gd=DETECT, gm, errcode;
  initgraph(&gd,&gm,GR_PATH);
  errcode=graphresult();
  if (errcode != grOk)
  {
    printf("gr. error\n");
    exit(1);
  }

  x_start=(-5);
  x_end=5;

  konec=1;
  while (konec)
  {
    if (x_end < x_start) { printf("ERROR - x_start < x_end\n\n"); }

    if ((x_start>=0) && (x_end>=0)) x_vzd=fabs(x_start-x_end);
    if ((x_start<0) && (x_end<0)) x_vzd=fabs(fabs(x_start)-fabs(x_end));
    if ((x_start<0) && (x_end>=0)) x_vzd=fabs(x_start)+x_end;
    krok_x=x_vzd / getmaxx();

    y_end=f_max();
    y_start=f_min();
    if ((y_start>=0) && (y_end>=0)) y_vzd=fabs(y_start-y_end);
    if ((y_start<0) && (y_end<0)) y_vzd=fabs(fabs(y_start)-fabs(y_end));
    if ((y_start>=0) && (y_end<0)) y_vzd=y_start+fabs(y_end);
    if ((y_start<0) && (y_end>=0)) y_vzd=fabs(y_start)+y_end;
    krok_y=y_vzd / getmaxy();

    draw_funkce();
    ch=getch();
    switch (ch)
    {
      case 27 : konec=0; break;
     // zoom in
     case '+' : x_start=x_start+(fabs(x_vzd)/5);
                x_end=x_end-(fabs(x_vzd)/5);
                break;
     // zoom out
     case '-' : x_start=x_start-(fabs(x_vzd)/5);
                x_end=x_end+(fabs(x_vzd)/5);
                break;
       case 0 : ch=getch();
                switch(ch)
                {
                  // left
                  case 75 : x_start=x_start-(fabs(x_vzd)/5);
                            x_end=x_end-(fabs(x_vzd)/5);
                            break;
                  // right
                  case 77 : x_start=x_start+(fabs(x_vzd)/5);
                            x_end=x_end+(fabs(x_vzd)/5);
                            break;
/*                  // up
                  case 72 : pozy--; break;
                  // down
                  case 80 : pozy++; break;*/
                }
                break;
    }
  }

  closegraph();
  clrscr();
  printf("(c)2001 by Jan Krupa(krupaj@mobilnews.cz)\n\n");
}